/*  (c) 2008 Benjamin Schroeter
 *  You are allowed to use this code in all your commercial, non-commercial, open and closed source projects.
 *  But you have to leave this Copyright message in all files. This code is provided "as is" without warranty of any kind.
 *  If you have any enhancements or bug reports I will appreciate a short feedback.
 *  For more information visit the article to this code on my blog at 
 *  http://www.ticklishtechs.net/2008/02/29/connectors-between-compartment-shape-entries-with-dsl-tools-part-1/ */
using Microsoft.VisualStudio.Modeling;

namespace BenjaminSchroeter.Dsl.CompartmentMapping
{
    /// <summary>
    /// Different parts of a compartment shape.
    /// </summary>
    public enum SelectedCompartmentPartType
    {
        None = 0,
        Head = 1,
        Element = 2
    }
    
    /// <summary>
    /// This class represents a part of a compartment shape.
    /// </summary>
    /// <remarks>
    /// This part can be the head or an compartment element
    /// </remarks>
    public class SelectedCompartmentPart
    {
        public SelectedCompartmentPartType Type = SelectedCompartmentPartType.None;
        public ModelElement Element;

        public SelectedCompartmentPart Clone()
        {
            return new SelectedCompartmentPart {Type = Type, Element = Element};
        }
    }
}